
#include "ReadVorbis.h"


ReadVorbis::ReadVorbis()
{
  char file;

}


void ReadVorbis::Initialize(const char *filename) 
{
  sprintf(file, "ogg vorbis file: %s", filename);

  if (fp != 0) {
    fclose(fp); fprintf(stderr, "already opened, now closing file");
  }
  fp = fopen( filename,  "r"); 
  if (fp == NULL) {
    fprintf(stderr,  "couldnt open file\n");
  } else { 
    //fprintf(stderr, "opening file: [%s] \n", filename);
  }  

  if(ov_open(fp, &vf, NULL, 0) < 0) {
    fprintf(stderr," does not appear to be an Ogg bitstream.\n");
    exit(1);
  }

  vi=ov_info(&vf,-1);
  //fprintf(stderr, "ReadVorbis: opening file: [%s] %d (Hz), %d chan(s)\n", 
  //  filename, vi->rate, vi->channels);
}

int ReadVorbis::Decode() {
  long ret;
  int current_section;
  float **buftmp;
  int x=0;

  ret=ov_read_float(&vf, &buftmp , CHUNKSIZE,  &current_section);

  if (vi->channels == 1) {
    for(int j = 0; j < ret; j++)
      {
	buffer[x++] = buftmp[0][j];
	buffer[x++] = buftmp[0][j];
      }
  } else {
    for(int j = 0; j < ret; j++)
      {
	buffer[x++] = buftmp[0][j];
	buffer[x++] = buftmp[1][j];
      }
  }
  return x;  //ret;

}


bool ReadVorbis::Rewind() {
  if ( ov_pcm_seek(&vf, 0) == 0)
    return true;
  else
    return false;
}

bool ReadVorbis::PCM_seek(long bytes) {
  if ( ov_pcm_seek(&vf, bytes) == 0)
    return true;
  else
    return false;

}

bool ReadVorbis::TIME_seek(double seconds) {
  if ( ov_time_seek(&vf, seconds) == 0)
    return true;
  else
    return false;
}
